commit 8f87e950f34c5ee1f695035329bb5fe7be1252f8
Author: Jan Pokorný <jpokorny@redhat.com>
Date:   Thu May 10 23:48:56 2018 +0200

    XML: upgrade-2.10.xsl: make diagnostics more direct wrt. context
    
    At least with op meta_attributes, it's been quite lacking so far
    compared to other parts.  Immediately inspired with the test suite
    where the handling was still quite confusing in the presence of
    multiple competing value propagation (or otherwise) sources.

diff --git a/xml/test-2/020-rsc-requires-inline.ref.err b/xml/test-2/020-rsc-requires-inline.ref.err
index a9e7a8967..a13b4f27b 100644
--- a/xml/test-2/020-rsc-requires-inline.ref.err
+++ b/xml/test-2/020-rsc-requires-inline.ref.err
@@ -1 +1 @@
-Resources-operation: moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: myAddr-start (rsc=myAddr): moving requires under meta_attributes as requires unless already defined there for matching start|promote
diff --git a/xml/test-2/021-rsc-requires-nvpair.ref.err b/xml/test-2/021-rsc-requires-nvpair.ref.err
index 2b5e0e00a..9a04c4732 100644
--- a/xml/test-2/021-rsc-requires-nvpair.ref.err
+++ b/xml/test-2/021-rsc-requires-nvpair.ref.err
@@ -1 +1 @@
-Resources-operation: myAddr-start: moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: myAddr-start (rsc=myAddr, meta=myAddr-start-metaparams): moving requires under meta_attributes as requires unless already defined there for matching start|promote
diff --git a/xml/test-2/022-rsc-requires-counterexamples.ref.err b/xml/test-2/022-rsc-requires-counterexamples.ref.err
index 4e9a8f7cd..5f89215b1 100644
--- a/xml/test-2/022-rsc-requires-counterexamples.ref.err
+++ b/xml/test-2/022-rsc-requires-counterexamples.ref.err
@@ -1,2 +1,2 @@
-Resources-operation: dropping requires
+Resources-operation: myAddr-stop (rsc=myAddr): dropping requires
 Resources-operation: ... only start/promote operation taken into account
diff --git a/xml/test-2/023-rsc-requires-no-override.ref.err b/xml/test-2/023-rsc-requires-no-override.ref.err
index 84a51c955..100fab93c 100644
--- a/xml/test-2/023-rsc-requires-no-override.ref.err
+++ b/xml/test-2/023-rsc-requires-no-override.ref.err
@@ -1,4 +1,4 @@
-Resources-operation: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: stateful-promote: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: stateful-demote: dropping requires
+Resources-operation: myAddr-start (rsc=myAddr): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful-promote (rsc=stateful, meta=stateful-promote-meta): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful-demote (rsc=stateful, meta=stateful-demote-meta): dropping requires
 Resources-operation: ... only start/promote operation taken into account
diff --git a/xml/test-2/024-rsc-requires-no-selfclash.ref.err b/xml/test-2/024-rsc-requires-no-selfclash.ref.err
index e6d575501..ea9586459 100644
--- a/xml/test-2/024-rsc-requires-no-selfclash.ref.err
+++ b/xml/test-2/024-rsc-requires-no-selfclash.ref.err
@@ -1,14 +1,14 @@
-Resources-operation: myAddr1-start: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: myAddr2-start: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: stateful1-demote: dropping requires
+Resources-operation: myAddr1-start (rsc=myAddr1, meta=myAddr1-start-meta): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: myAddr1-start (rsc=myAddr1): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: myAddr2-start (rsc=myAddr2, meta=myAddr2-start-meta): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: myAddr2-start (rsc=myAddr2): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful1-promote (rsc=stateful1): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful1-start (rsc=stateful1): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful1-demote (rsc=stateful1, meta=stateful1-demote-meta): dropping requires
 Resources-operation: ... only start/promote operation taken into account
-Resources-operation: stateful2-promote: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: stateful2-promote: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: stateful2-promote: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: stateful2-start: moving requires under meta_attributes as requires unless already defined there for matching start|promote
-Resources-operation: stateful2-demote: dropping requires
+Resources-operation: stateful2-promote (rsc=stateful2, meta=stateful2-promote-meta1): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful2-promote (rsc=stateful2, meta=stateful2-promote-meta1): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful2-promote (rsc=stateful2, meta=stateful2-promote-meta2): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful2-start (rsc=stateful2, meta=stateful2-promote-meta3): moving requires under meta_attributes as requires unless already defined there for matching start|promote
+Resources-operation: stateful2-demote (rsc=stateful2, meta=stateful2-promote-meta): dropping requires
 Resources-operation: ... only start/promote operation taken into account
diff --git a/xml/upgrade-2.10.xsl b/xml/upgrade-2.10.xsl
index f08956655..2911fb0fa 100644
--- a/xml/upgrade-2.10.xsl
+++ b/xml/upgrade-2.10.xsl
@@ -897,7 +897,11 @@
                       or
                       $InnerPass = 'TRIGGER-MSG'">
           <xsl:call-template name="MapMsg">
-            <xsl:with-param name="Context" select="../../@id"/>
+            <xsl:with-param name="Context"
+                            select="concat(../../@id,
+                                           ' (rsc=', $EnclosingTag/@id,
+                                           ', meta=', ../@id,
+                                           ')')"/>
             <xsl:with-param name="Replacement" select="$Replacement"/>
           </xsl:call-template>
         </xsl:if>
@@ -1097,7 +1101,10 @@
                             ]"/>
       <xsl:if test="not($InverseMode or $InnerSimulation)">
         <xsl:call-template name="MapMsg">
-          <xsl:with-param name="Context" select="../../@id"/>
+          <xsl:with-param name="Context"
+                                select="concat(../@id,
+                                               ' (rsc=', $EnclosingTag/@id,
+                                               ')')"/>
           <xsl:with-param name="Replacement" select="$Replacement"/>
         </xsl:call-template>
       </xsl:if>
